-module(element_file).
%%-author('Vladimir Galunshchikov').

-include_lib("nitro/include/nitro.hrl").
-include_lib("nitro/include/event.hrl").

-export([
  render_element/1
]).


render_element(Record) when Record#file.show_if == false -> [<<>>];

render_element(Record) ->
  Id = case Record#file.postback of
    [] -> Record#file.id;
    Postback ->
      ID0 = case Record#file.id of
        [] -> nitro:temp_id();
        I -> I
      end,
      nitro:wire( #event{type = click, postback = Postback, target = ID0,
                         source = Record#file.source,
                         delegate = Record#file.delegate} ),
      ID0
  end,
  List = [
    %% global
    {<<"accesskey">>, Record#file.accesskey},
    {<<"class">>, Record#file.class},
    {<<"contenteditable">>,
       case Record#file.contenteditable of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"contextmenu">>, Record#file.contextmenu},
    {<<"dir">>,
       case Record#file.dir of
         "ltr" -> "ltr";
         "rtl" -> "rtl";
         "auto" -> "auto";
         _ -> []
       end},
    
    {<<"draggable">>,
       case Record#file.draggable of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"dropzone">>, Record#file.dropzone},
    {<<"hidden">>,
       case Record#file.hidden of
         "hidden" -> "hidden";
         _ -> []
       end},
    
    {<<"id">>, Id},
    {<<"lang">>, Record#file.lang},
    {<<"spellcheck">>,
       case Record#file.spellcheck of
         true -> "true";
         false -> "false";
         _ -> []
       end},
    
    {<<"style">>, Record#file.style},
    {<<"tabindex">>, Record#file.tabindex},
    {<<"title">>, Record#file.title},
    {<<"translate">>,
       case Record#file.contenteditable of
         "yes" -> "yes";
         "no" -> "no";
         _ -> []
       end},
    
    %% spec
    {<<"accept">>, Record#file.accept},
    {<<"autofocus">>,
       case Record#file.autofocus of
         true -> "autofocus";
         _ -> []
       end},
    
    {<<"disabled">>,
       case Record#file.disabled of
         true -> "disabled";
         _ -> []
       end},
    
    {<<"form">>, Record#file.form},
    {<<"multiple">>,
       case Record#file.multiple of
         true -> "multiple";
         _ -> []
       end},
    
    {<<"name">>, Record#file.name},
    {<<"required">>,
       case Record#file.required of
         true -> "required";
         _ -> []
       end},
    
    {<<"type">>, <<"file">>} | Record#file.data_fields
  ],
  
  wf_tags:emit_tag(<<"input">>, nitro:render(Record#file.body), List).

